Attribute VB_Name = "cmdLineParser"
Option Explicit

Private Const ChrSpace As String = " "
Private Const ChrQuote As String = """"
' GetCommandLine
'       Split the command line into individual params
'
Public Sub GetCommandLine(ByRef strParams() As String)
    Dim tempStr As String
    Dim pos(1) As Long
    
    ReDim strParams(0) As String
    tempStr = Command
    
    ' check for even number of quotes
    If CountQuotes(tempStr) Mod 2 = 1 Then
        Exit Sub
    Else
        pos(0) = 1
        pos(1) = 1
        Do Until InStr(pos(0), tempStr, ChrSpace) = 0
       
            'find the next space
            pos(1) = InStr(pos(0), tempStr, ChrSpace)
            
            'check for matched quotes within this segment
            If CountQuotes(Mid(tempStr, pos(0), pos(1) - pos(0))) Mod 2 = 1 Then
                pos(1) = InStr(pos(1), tempStr, ChrQuote) + Len(ChrQuote)
            End If
            
            'store the param
            If pos(1) > 0 Then
                AddParam strParams, Mid(tempStr, pos(0), pos(1) - pos(0))
                'bump up to next position
                pos(0) = pos(1) + 1
            Else
                Stop
            End If
        
        Loop
        
        '
        If pos(0) < Len(tempStr) Then
            pos(1) = Len(tempStr) + 1
            AddParam strParams, Mid(tempStr, pos(0), pos(1) - pos(0))
        End If
        
    End If

End Sub


' AddParam
'     Add a new item into the params array
'
Private Sub AddParam(ByRef strParams() As String, ByVal sNewString As String)

    'resize if need be, preserving existing contents
    If strParams(0) <> vbNullString Then
        ReDim Preserve strParams(UBound(strParams) + 1) As String
    End If
    
    'Remove surrounding quotes if they exist
    If left(sNewString, 1) = ChrQuote And Right(sNewString, 1) = ChrQuote Then
        sNewString = Mid(sNewString, 2, Len(sNewString) - 2)
    End If
    
    'Store it
    strParams(UBound(strParams)) = sNewString

End Sub


' CountQuotes
'       Count the number of quote chars in a given string
'
Private Function CountQuotes(ByVal sInput As String) As Long
    Dim pos As Long
    
    CountQuotes = 0
    pos = 1
    Do Until InStr(pos, sInput, ChrQuote) = 0
        CountQuotes = CountQuotes + 1
        pos = InStr(pos, sInput, ChrQuote) + Len(ChrQuote)
    Loop

End Function
