Attribute VB_Name = "customTypes"
' customTypes.bas (customTypes)
'
'     Shared definitions for the ReportsWatcher forms.
'
' Copyright 2011 Sonic Solutions. Portions Copyright 1989-2011 EMC Corporation.

Public Enum ColumnIDs
    kBkupDate = 0               '    0 Backup Date
    kBkupTime                   '    1 Backup Time
    kMachineName                '    2 Machine Name
    kSourceName                 '    3 Source Name
    kBkupSetName                '    4 Backup Set Name
    kAction                     '    5 Action
    kNonFatalErrs               '    6 Non Fatal Errors
    kFatalErr                   '    7 Fatal Error
    kErrName                    '    8 Error Name
    kKBStored                   '    9 KB Stored
    kKBTransferred              '   10 KB Transferred
    kNumFilesCopied             '   11 Files Copied
    kDuration                   '   12 Duration (in 00:00:00 format)
    kScriptName                 '   13 Script Name
    kScriptStartDate            '   14 Script Start Date
    kScriptStartTime            '   15 Script Start Time
    kSubVolParent               '   16 Subvolume Parent
    kMaxColumns                 '   17 (Also the activator code on a mac)
    kMacSubVolParent            '   18 Macintosh subvolume parent name (only on mac)
End Enum

Public Enum ReportTypes
    kSummary = 1
    kReport
    kSuccess
    kError
    kNever
    kLog
End Enum

Public Enum SectionTypes
    kHead = 1
    kFoot
End Enum

Public Enum OptionDataTypes
    kUpdateFreq = 1
    kNoteInterval
    kNoteHTML
    kWarnInterval
    kWarnHTML
End Enum

Public Type Coor
    x As Integer
    y As Integer
End Type

Public Type Rect
    left As Integer
    top As Integer
    width As Integer
    height As Integer
End Type

Public Type HtmlData
    head As String
    foot As String
End Type

Public Type GlobalData
    srcPath As Variant
    destPath As Variant
    
    updateFreq As Long
    noteInterval As Long
    warnInterval As Long
    
    warnHTML As String
    noteHTML As String
    
    rep As HtmlData
    sum As HtmlData
    suc As HtmlData
    err As HtmlData
    nvr As HtmlData
End Type

Public Type SummaryInfo
    serverName As String
    numBkups As Long
    numFails As Long
    numNever As Long
    oldBkup As Date
    recentBkup As Date
    bkupCmt As String
    failCmt As String
    repDestName As String
    sucDestName As String
    failDestName As String
End Type

